var Est90000_PerfilOperadoresInventarioCego_Controller = function(templateManager, ScreenService, MessageService, General, EstUtil, ZHPromise, ZhFilterPreferences, Est90000_PerfilOperadoresInventarioCego_Services) {

    //Operation Widget Functions
    this.onAddOperation = function(widget) {
        widget.newRow();
        General.setEnableField('NMOPERADOR', widget.name);
        widget.currentRow.IDGEST = "N";
        widget.currentRow.IDGGER = "N";
        widget.currentRow.IDGAUD = "N";
    };

    this.onSaveOperation = function(widget) {
        const currentRow = widget.currentRow;

        if (currentRow.IDGEST === 'N' && currentRow.IDGGER === 'N' && currentRow.IDGAUD === 'N') {
            return MessageService.showMessageByCode('BLOCK_NO_PROFILE_OPERATOR_SELECTED');
        }
        Est90000_PerfilOperadoresInventarioCego_Services.onSaveOperation(widget.currentRow).then((saved) => {
            widget.reload().then(() => {
                ScreenService.goBack();
                widget.list();
            });
        }).catch(
            error => {
                if (error.data)
                    ScreenService.showMessage(error.data.error);
                else
                    ScreenService.showMessage(error);
            }
        );
    };

    this.onDeleteOperation = function(widget) {
        MessageService.confirmMessageByCode('lib#GEN_DELETE_REG').then((success) => {
            Est90000_PerfilOperadoresInventarioCego_Services.onDeleteOperation(widget.currentRow).then((saved) => {
                ScreenService.closeSwipe();
                widget.reload();
            }).catch(
                error => {
                    if (error.data)
                        ScreenService.showMessage(error.data.error);
                    else
                        ScreenService.showMessage(error);
                }
            );
        });
    };

    this.onChangeOperatorField = function(widget) {
        const data = widget.dataSource.data;
        const currentRow = widget.currentRow;

        let check = data.filter(oper => oper.CDOPERADOR === currentRow.CDOPERADOR && oper.__is_new !== true);
        
        return check.length !== 0 ? MessageService.showMessageByCode('BLOCK_OPERATOR_CODE_DUPLICATED') : "";

    };

    //Support Functions

    this.changeHideInconLabelVisible = function(data, label, hide, name, visibility) {
        data.forEach(element => {
            if (element.name === name) {
                element.label = label;
                element.hideIcon = hide;
                element.isVisible = visibility;
            }
        });
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('Est90000_PerfilOperadoresInventarioCego_Controller', Est90000_PerfilOperadoresInventarioCego_Controller);
});
