function Ger09700_ProjecaoDeEstoque_Controller(templateManager, ZhLayoutPreferences, ZhFilterPreferences, ScreenService, MessageService, ZhUtil, maskEngine, EstUtil) {

	this.openFilter = function(widget) {
		ScreenService.showLoader();
		this.setFieldsGerais(widget);
		const rowsToSet = {};
		const tipoCustoField = widget.getField('NMTIPOCUSTO');
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.REPORT_NAME = "GER09700";
		rowsToSet.DTLEV = {
			formattedStart: moment().format('L'),
			formattedEnd: moment().format('L'),
			start: moment().format('L'),
			end: moment().format('L'),
		};
		rowsToSet.TFILESTOQ = 'T';
		rowsToSet.TFILIROM = 'T';
		rowsToSet.TSERIROM = 'T';
		rowsToSet.CDOPERADOR = getLocalVar('CDOPERADOR');

		tipoCustoField.reload().then(() => {
			rowsToSet.CDTIPOCUSTO = tipoCustoField.dataSource.data[0].CDTIPOCUSTO;
			rowsToSet.NMTIPOCUSTO = ScreenService.i18n(tipoCustoField.dataSource.data[0].NMTIPOCUSTO);

			ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
				var filtro = widget.container.getActiveWidget();
				this.filiProd(filtro);
				this.onChangeReport(filtro);
				filtro.reload();
				ScreenService.hideLoader();
			}).catch(error => {
				console.log(error);
				ScreenService.hideLoader();
			});
		});
	};

	this.filterValidations = function(args) {
		let filterRow = args.e.preference.FILTER_ROW;

		if (filterRow.REPORT_NAME == 'GER09700Dis' && filterRow.IDFUNCAOFILI != 'O') {
			args.e.preventDefault();
			return MessageService.showMessageByCode('BLOCK_UNITY_SHOULD_BE_LOGISTC_OPERATOR');
		}
	};

	this.onChangeReport = function(widget) {
		const reportName = widget.currentRow.REPORT_NAME;
		let fieldsToHideOrClear, fieldsToShow;

		switch (reportName) {
			case 'GER09700':
				{
					fieldsToHideOrClear = [
						'NMFILESTOQ',
						'NMFILIROM',
						'DSSERIE',
						'DTENTRPEN',
						'DTSAIPEN',
						'TFILESTOQ',
						'TFILIROM',
						'TSERIROM'
					];
					this.hideFieldsManager(widget, fieldsToHideOrClear);

					fieldsToShow = [
						'CONSSOL',
						'CONSAF',
						'CONSEST',
						'CONSROM'
					];
					this.showFieldsManager(widget, fieldsToShow);
					break;
				}
			case 'GER09700Dis':
				{
					fieldsToHideOrClear = [
							'NMFILESTOQ',
							'NMFILIROM',
							'DSSERIE',
							'TFILESTOQ',
							'TFILIROM',
							'CONSSOL',
							'CONSAF',
							'CONSEST',
							'CONSROM',
							'TSERIROM'
						];
					this.hideFieldsManager(widget, fieldsToHideOrClear);

					fieldsToShow = [
						'DTENTRPEN',
						'DTSAIPEN'
					];
					this.showFieldsManager(widget, fieldsToShow);
					break;
				}
			default:
				// code
		}
		// widget.reload();
	};

	this.hideFieldsManager = function(widget, fieldsToHideOrClear) {

		const hideFieldsManager = (field) => {
			const exceptionHideFields = [
				'NMPRODINI'
			];

			if (field.template == 'field/checkbox.html') {
				field.setValue('N');
				field.checked = false;
			}
			else
				field.clearValue();

			if (exceptionHideFields.includes(field.name))
				field.readOnly = false;
			else
				field.readOnly = true;

			delete field.validations.required;
		};

		const fieldsHidePack = widget.fields.filter(field => {
			return fieldsToHideOrClear.includes(field.name);
		});

		fieldsHidePack.forEach(field => {
			hideFieldsManager(field);
			field.reload();
		});
	};

	this.showFieldsManager = function(widget, fieldsToShow) {
		const showFieldsManager = (field) => {
			const requiredFieldsBag = [
				"NMPRODINI",
				"NMTIPOCUSTO",
				"NMFILIAL",
				"REPORT_NAME",
				"DTLEV"
			];

			if (requiredFieldsBag.includes(field.name))
				field.validations.required = true;
			else
				delete field.validations.required;

			field.readOnly = false;
		};

		const fieldShowBag = widget.fields.filter(field => {
			return fieldsToShow.includes(field.name);
		});

		fieldShowBag.forEach(field => {
			showFieldsManager(field);
			field.reload();
		});
	};

	this.filiProd = function(widget) {
		var row = widget.currentRow;
		var filialIsSet = this.fieldIsSet(row.CDFILIAL);
		if (!filialIsSet) {
			widget.currentRow.NMPRODINI = '';
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.P_CDPRODINI = '';
			widget.currentRow.P_CDPRODFIN = '';
			widget.getField('NMPRODFIN').readOnly = true;
			widget.getField('NMPRODFIN').readOnlyOnEdit = true;
		}
		if (row.NMFILIAL && (row.NMFILIAL != "")) {
			widget.getField('NMPRODINI').dataSourceFilter.forEach(function(fil) {
				if (fil.name === 'CDFILIAL') {
					fil.value = widget.currentRow.CDFILIAL;
				}
			});
			widget.getField('NMPRODFIN').dataSourceFilter.forEach(function(fil) {
				if (fil.name === 'CDFILIAL') {
					fil.value = widget.currentRow.CDFILIAL;
				}
			});
		}
		widget.getField('NMPRODINI').reload();
		widget.getField('NMPRODFIN').reload();
		widget.getField('NMPRODINI').readOnly = false;
		widget.getField('NMPRODINI').readOnlyOnEdit = false;
		widget.getField('NMPRODINI').reload();
		widget.getField('NMPRODFIN').reload();
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};

	this.changeFieldUnidadeEstoque = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if (args.row.TFILESTOQ == 'T') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILESTOQ").readOnly = true;
					widget.getField("NMFILESTOQ").readOnlyOnEdit = true;
					delete widget.getField("NMFILESTOQ").validations.required;
					widget.currentRow.NMFILESTOQ = "";
					widget.currentRow.CDFILESTOQ = "";
					widget.getField("NMFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
		else if (args.row.TFILESTOQ == 'L') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILESTOQ").readOnly = false;
					widget.getField("NMFILESTOQ").readOnlyOnEdit = false;
					widget.getField("NMFILESTOQ").validations.required = true;
					widget.getField("NMFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};

	this.changeFieldUnidadeRomaneio = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if (args.row.TFILIROM == 'T') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILIROM").readOnly = true;
					widget.getField("NMFILIROM").readOnlyOnEdit = true;
					delete widget.getField("NMFILIROM").validations.required;
					widget.currentRow.NMFILIROM = "";
					widget.currentRow.CDFILIROM = "";
					widget.getField("NMFILIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
		else if (args.row.TFILIROM == 'L') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("NMFILIROM").readOnly = false;
					widget.getField("NMFILIROM").readOnlyOnEdit = false;
					widget.getField("NMFILIROM").validations.required = true;
					widget.getField("NMFILIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};

	this.changeFieldSerieNF = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if (args.row.TSERIROM == 'T') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("DSSERIE").readOnly = true;
					widget.getField("DSSERIE").readOnlyOnEdit = true;
					delete widget.getField("DSSERIE").validations.required;
					widget.currentRow.DSSERIE = "";
					widget.currentRow.CDSERIE = "";
					widget.getField("DSSERIE").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
		else if (args.row.TSERIROM == 'L') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("DSSERIE").readOnly = false;
					widget.getField("DSSERIE").readOnlyOnEdit = false;
					widget.getField("DSSERIE").validations.required = true;
					widget.getField("DSSERIE").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};

	this.fieldIsSet = function(fieldValue) {
		if (fieldValue) return true;
		else return false;
	};

	this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);
		if (!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				widget.getField('NMPRODFIN').readOnly = true;
				widget.getField('NMPRODFIN').readOnlyOnEdit = true;
				widget.getField('NMPRODFIN').clearValue();
			}
		}
		else if (widget.name === "zhFilterPreferencesSelectConditions") {
			widget.getField('NMPRODFIN').readOnly = false;
			widget.getField('NMPRODFIN').readOnlyOnEdit = false;
		}
		this.checkProductRange(args.owner.field);
	};

	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = this.fieldIsSet(row.CDPRODFIN);
		var prodIniIsSet = this.fieldIsSet(row.CDPRODINI);

		if (!prodIniIsSet) {
			widget.getField('NMPRODFIN').readOnly = true;
			widget.getField('NMPRODFIN').readOnlyOnEdit = true;
			widget.getField('NMPRODFIN').clearValue();
			widget.getField('NMPRODFIN').reload();
		}

		this.checkProductRange(args.owner.field);
	};

	this.checkProductRange = function(field) {
		var currentRow = field.widget.currentRow;

		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {

				MessageService.showMessageByCode("PRODUTO_INICIAL_MAIOR_FINAL").then(success => {
					currentRow[field.outData[field.descriptionField]] = null;
					currentRow[field.outData[field.valueField]] = null;
					currentRow.CDPRODFIN = null;
					field.widget.getField('NMPRODFIN').clearValue();
					field.widget.getField('NMPRODFIN').reload();
				}).catch(error => {
					console.log(error);
				});
			}
		}
	};

	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
		var mask = {
			type: "fix",
			params: {
				mask: mascara
			}
		};
		pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
		pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
		var nvinicial = pinicial.length;
		var nvfinal = pfinal.length;
		var resultado = true;
		if (nvinicial != nvfinal) {
			if (nvinicial > nvfinal) {
				resultado = false;
			}
		}
		else {
			var i = 0;
			do {
				if (pinicial[i] > pfinal[i]) {
					resultado = false;
				}
				i++;
			}
			while (i < pinicial.length && resultado);
		}
		return resultado;
	};

	this.changeBlockEstoque = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if (args.row.CONSEST == 'N') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILESTOQ").readOnly = true;
					widget.getField("TFILESTOQ").readOnlyOnEdit = true;
					if (widget.getField("TFILESTOQ").value() == 'L') {
						widget.currentRow.TFILESTOQ = 'T';
						this.changeFieldUnidadeEstoque(args);
					}
					widget.getField("TFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
		else {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILESTOQ").readOnly = false;
					widget.getField("TFILESTOQ").readOnlyOnEdit = false;
					widget.getField("TFILESTOQ").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};

	this.changeBlockRomaneio = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if (args.row.CONSROM == 'N') {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILIROM").readOnly = true;
					widget.getField("TFILIROM").readOnlyOnEdit = true;
					if (widget.getField("TFILIROM").value() == 'L') {
						widget.currentRow.TFILIROM = 'T';
						this.changeFieldUnidadeRomaneio(args);
					}
					widget.getField("TFILIROM").reload();
					widget.getField("TSERIROM").readOnly = true;
					widget.getField("TSERIROM").readOnlyOnEdit = true;
					if (widget.getField("TSERIROM").value() == 'L') {
						widget.currentRow.TSERIROM = 'T';
						this.changeFieldSerieNF(args);
					}
					widget.getField("TSERIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
		else {
			if (widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("TFILIROM").readOnly = false;
					widget.getField("TFILIROM").readOnlyOnEdit = false;
					widget.getField("TFILIROM").reload();
					widget.getField("TSERIROM").readOnly = false;
					widget.getField("TSERIROM").readOnlyOnEdit = false;
					widget.getField("TSERIROM").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};

	this.defineIdiomaTipoCusto = function(widget, filter = true) {
		const custoField = widget.getField('NMTIPOCUSTO');
		// setLocalVar('language', 'es_cl');
		const idioma = getLocalVar('language');

		const nomeField = {
			pt_br: 'NMTIPOCUSTO',
			en_us: 'NMTIPOCUSING',
			es_es: 'NMTIPOCUSESP',
			es_cl: 'NMTIPOCUSESP',
			es_co: 'NMTIPOCUSESP',
			es_mx: 'NMTIPOCUSESP',
		};

		let fields = custoField.fields;

		fields.forEach(function(field) {
			if (field.name == nomeField[idioma] || field.name == 'CDTIPOCUSTO')
				field.isVisible = true;
			else
				field.isVisible = false;
		});

		custoField.displayedFields[1] = nomeField[idioma];
		custoField.searchableFields[1] = nomeField[idioma];
		delete custoField.outData.NMTIPOCUSTO;
		custoField.outData[nomeField[idioma]] = "NMTIPOCUSTO";

		custoField.reload();
		
		if(filter == true){
			this.defineIdiomaTipoCusto(EstUtil.getFilterWidget(widget), false);
		}
	};

	this.GridFieldsVisibilityManager = function() {
		const widget = templateManager.container.getWidget('widgetProjecao');
		const widgetFields = widget.fields.map(field => field.name);
		const changeFieldsVisibility = (VisibleFields, widgetFields) => {
			widgetFields.forEach(field => {
				if (VisibleFields.includes(field)) {
					widget.getField(field).isVisible = true;
					widget.getField(field).showOnList = true;
				}
				else {
					widget.getField(field).isVisible = false;
					widget.getField(field).showOnList = false;
				}
			});
		};
		const fieldUnityGroud = widget.getField('UNIDADEAGRUP');
		const reportName = EstUtil.getFieldValue('REPORT_NAME', widget.name, true);
		let VisibleFields = [];

		switch (reportName) {
			case 'GER09700':
				VisibleFields = [
					'CDPROESTPROJ',
					'NMPRODUTO',
					'SGUNIDADE',
					'QTPRODSOLI',
					'QTPRODROMA',
					'QTPRODNFPREV',
					'QTPRODLANCAF',
					'QTPRODESTOQ',
					'QTPROJESTPRO',
					'DTPRIFALTEST'
				];
				changeFieldsVisibility(VisibleFields, widgetFields);
				delete widget.getField('VRTOTAL').expression;
				fieldUnityGroud.grouped = false;
				fieldUnityGroud.isVisible = false;
				break;
			case 'GER09700Dis':
				VisibleFields = [
					'CDPROESTPROJ',
					'NMPRODUTO',
					'SGUNIDADE',
					'POSICAO',
					'VRCUSTOPROD',
					'VRTOTAL',
					'QTDE',
					'ENTRADAS',
					'SAIDAS',
					'SALDO'

				];
				changeFieldsVisibility(VisibleFields, widgetFields);
				widget.getField('VRTOTAL').expression = 'SUM';
				fieldUnityGroud.grouped = true;
				fieldUnityGroud.isVisible = true;
				break;
		}
		widget.redraw();
		// templateManager.updateTemplate();

	};

	this.reportProcess = function(args, afterOpenReport = false) {
		const { owner: widget } = args;

		if (afterOpenReport) {
			ZhLayoutPreferences.applyOriginalLayout(widget);
		}
		else {
			const metadata = args.e.metadata;
			const reportName = EstUtil.getFieldValue('REPORT_NAME', widget.name, true);
			const UnityName = EstUtil.getFieldValue('NMFILIAL', widget.name, true);
			const UnityCode = EstUtil.getFieldValue('CDFILIAL', widget.name, true);
			let { start } = EstUtil.getFieldValue('DTLEV', widget.name, true);

			const logisticOperator = metadata.filter.filter(filter => filter.label == 'Operador Logístico');
			logisticOperator[0].value = UnityCode + ' - ' + UnityName;
				
			metadata.filter.push({
				label: "Dt. Posição",
				value: start
			});
			
			if(reportName == 'GER09700Dis'){
				metadata.title = 'Projeção de Estoque - Distribuição';
				metadata.orientation = 'LANDSCAPE';
				
			}else{
				metadata.title = 'Projeção de Estoque';
				metadata.orientation = 'PORTRAIT';
			}
			ZhLayoutPreferences.applyOriginalLayout(widget);
		}
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Ger09700_ProjecaoDeEstoque_Controller', Ger09700_ProjecaoDeEstoque_Controller);
});
